Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_PublicObject

    java.lang.Object
      oracle.ifs.server.S_LibraryObject
          oracle.ifs.server.S_TieLibraryObject
              oracle.ifs.server.S_PublicObject

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  S_TiePublicObject

    public class S_PublicObject

extends S_TieLibraryObject
implements PublicObjectInterface

The S_PublicObject class is the server side implementation of the CM SDK PUBLICOBJECT class.

(Published)

Field Summary
`protected static java.lang.String` | `ACL_ATTRIBUTE`
`static java.lang.String` | `CLASS_NAME`
`protected static java.lang.String` | `CREATEDATE_ATTRIBUTE`
`protected static java.lang.String` | `CREATOR_ATTRIBUTE`
`protected static java.lang.String` | `DELETOR_ATTRIBUTE`
`protected static java.lang.String` | `EXPIRATIONDATE_ATTRIBUTE`
`protected static java.lang.String` | `FAMILY_ATTRIBUTE`
`protected static java.lang.String` | `LASTMODIFIER_ATTRIBUTE`
`protected static java.lang.String` | `LASTMODIFYDATE_ATTRIBUTE`
`protected static java.lang.String` | `NAME_ATTRIBUTE`
`protected static java.lang.String` | `OWNER_ATTRIBUTE`
`static int` | `POLICY_ENUM_EXTENDEDFREE_IGNORE_OWNERSHIP`
`static int` | `POLICY_ENUM_EXTENDEDFREE_INVALID_VALUE`
`static int` | `POLICY_ENUM_EXTENDEDFREE_REQUIRE_ADMIN`
`protected static java.lang.String` | `POLICYBUNDLE_ATTRIBUTE` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`protected static java.lang.String` | `RESOLVED_OBJECT_ATTRIBUTE`
`protected static java.lang.String` | `SECURINGPUBLICOBJECT_ATTRIBUTE`

Fields inherited from class oracle.ifs.server.S_LibraryObject
`CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDEFINED, CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY, DEFAULT_RENDERER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `S_PublicObject(S_LibrarySession session, java.lang.Long classId)` Construct a S_PublicObject object.
`protected` | `S_PublicObject(S_LibrarySession session, java.lang.Long id, java.lang.Long classId)` Construct a S_PublicObject object.
`protected` | `S_PublicObject(S_LibrarySession session, S_LibraryObjectData data)` Construct a S_PublicObject object.

Method Summary
`protected S_Category` | `addCategory(S_LibraryObjectDefinition catdef)` Add a Category to the target object.
`protected S_LibraryObjectData` | `addRelationship(S_LibraryObjectDefinition def)` Add a relationship to another public object
`void` | `addRelationship(S_PublicObject rightPo, S_LibraryObjectDefinition def)` Add a relationship to another public object
`protected boolean` | `canUseContentQuota(S_ContentQuota quota)` Returns true if the current user can use the specified ContentQuota object.
`protected void` | `cascadeCopy(OperationState opState, S_LibraryObjectDefinition def, S_LibraryObject clone)` cascade operations to be performed before copying an object.
`protected void` | `cascadeDelete(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before deleting an object.
`protected void` | `cascadeFree(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before freeing an object.
`protected void` | `cascadeUndelete(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before undeleting an object.
`boolean` | `checkAccess(AccessLevel level)` Checks to see if the current user has the set of permissions specified for the target object.
`protected static S_PublicObject[]` | `constructPublicObjectArray(S_LibrarySession sess, java.lang.Long[] ids)` Construct a Folder array from an array of object IDs.
`protected void` | `createCategories(S_LibraryObjectDefinition sdef)` Create a set of categories.
`S_PolicyPropertyBundle` | `createDefaultPolicyPropertyBundle()` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`S_PropertyBundle` | `createDefaultPropertyBundle()` Creates a PropertyBundle for this PublicObject.
`protected void` | `delete(OperationState opState)` delete - THE ONLY METHOD THAT SHOULD CALL THIS METHOD IS S_LibrarySession.DMDelete() (or this method recursively).
`protected void` | `delete(OperationState opState, S_LibraryObjectDefinition def)` delete - THE ONLY METHOD THAT SHOULD CALL THIS METHOD IS S_LibrarySession.DMDelete() (or this method recursively).
`protected void` | `deriveDefinition(S_LibraryObjectDefinition sdef)` Add to the S_LibraryObjectDefinition for this class.
`protected S_PublicObject` | `determineResolvedObject()` return the object we resolve to.
`java.io.Serializable` | `DYNReplaceCreator(java.io.Serializable payload)` Changes the creator of an object to the passed in user.
`java.io.Serializable` | `DYNReplaceDeletor(java.io.Serializable payload)` Changes the deletor of an object to the passed in user.
`java.io.Serializable` | `DYNReplaceModifier(java.io.Serializable payload)` Changes the last modifier of an object to the passed in user.
`protected void` | `extendedPostDelete(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed after deleting an object.
`protected void` | `extendedPostFree(OperationState opState, S_LibraryObjectDefinition def)` Operations to be performed after freeing an object
`protected void` | `extendedPostInsert(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed after creating an object.
`protected void` | `extendedPostUndelete(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed after undeleting an object.
`protected void` | `extendedPostUpdate(OperationState opState, S_LibraryObjectDefinition def)` extended operations to be performed after updating an object.
`protected void` | `extendedPreCopy(OperationState opState, S_LibraryObjectDefinition sdef)` Operations to be performed prior to creating an object copy.
`protected void` | `extendedPreDelete(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed before deleting an object.
`protected void` | `extendedPreFree(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed before freeing an object.
`protected void` | `extendedPreInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Update any system attributes appropriate for creating this object
`protected void` | `extendedPreUndelete(OperationState opState, S_LibraryObjectDefinition def)` operations to be performed before undeleting an object.
`protected void` | `extendedPreUpdate(OperationState opState, S_LibraryObjectDefinition sdef)` Update any system attributes appropriate for creating this object
`protected void` | `forceSecuredObjectsToClear(OperationState opState)` for objects that we secure, if they haven't been freed as part of the specified operation, then force them to clear their SecuringPublicObject setting.
`protected void` | `freeIfNoFolderReferences(S_LibraryObjectDefinition sdef)` free this instance if there are no left-side FolderPathRelationships.
`protected void` | `freeNonsharedAcl(OperationState opState)`
`protected void` | `freeNonsharedLockObject(OperationState opState, S_LockObject ourlockobj)`
`protected S_AccessControlList` | `getAcl()` gets the ACL for this object, which can be null.
`java.lang.String[]` | `getAllFolderPaths()` Gets all Folder paths to the target object, starting from the Root Folder.
`java.lang.String[]` | `getAllFolderPaths(S_Folder reference)` get all Folder paths to the target object.
`java.lang.String[]` | `getAllFolderPaths(S_Folder reference, SortSpecification sort)` get all Folder paths to the target object.
`java.lang.String[]` | `getAllFolderPaths(S_Folder reference, SortSpecification sort, FolderPathOptions fpo)` get all Folder paths to the target object.
`protected S_Relationship[]` | `getAllLeftRelationships()` getAllLeftRelationships - gets all Relationship objects to the left of this object.
`protected S_Relationship[]` | `getAllRightRelationships()` getAllRightRelationships - gets all Relationship objects to the right of this object.
`java.lang.String` | `getAnyFolderPath()` Gets any Folder path to the target object, starting from the Root Folder.
`java.lang.String` | `getAnyFolderPath(S_Folder reference)` Gets any Folder path to the target object.
`java.lang.String` | `getAnyFolderPath(S_Folder reference, SortSpecification sort)` Gets any Folder path to the target object.
`java.lang.String` | `getAnyFolderPath(S_Folder reference, SortSpecification sort, FolderPathOptions fpo)` Gets any Folder path to the target object.
`S_Folder` | `getAuditEventFolderContext()` Gets the folder context for the target of an Audit Event.
`S_Category[]` | `getCategories()` Get all categries associated with this instance.
`S_Category[]` | `getCategories(S_ClassObject classobj)` Returns the associated Category objects that are instances of the ClassObject (or one of its subclasses) specified.
`S_Category[]` | `getCategories(SortSpecification sort)` Get all categories associated with this instance.
`S_Category` | `getCategory(S_ClassObject classobj)` Returns the associated Category object that is an instance of the ClassObject (or one of its subclasses) specified.
`protected long` | `getConsumedStorage()` Returns 0 as the storage consumed by PublicObject.
`protected AttributeValue` | `getDefaultAclFromUserProfile(java.lang.Long classid)` Get the defaultACL for a specified class of object, based on the current user's primaryUserProfile's DEFAULTACLS propertyBundle.
`protected S_Family` | `getFamily()` gets the S_Family of this object (or null for non-versioned)
`long` | `getFlags()` Gets the flags bitmask.
`protected S_Relationship[]` | `getLeftRelationships(java.lang.String relClassName)` getLeftRelationships - gets all Relationship objects to the left of this object for a specified Relationship class.
`protected java.util.Vector` | `getLeftwardRelationshipDatas(S_ClassObject relClass, SortSpecification sort)`
`protected java.util.Vector` | `getLeftwardRelationshipDatas(java.lang.String relClassName, SortSpecification sort)`
`protected java.util.Vector` | `getLeftwardRelationshipObjectDatas(S_ClassObject relClass, SortSpecification sort)`
`protected java.util.Vector` | `getLeftwardRelationshipObjectDatas(java.lang.String relClassName, SortSpecification sort)`
`S_PublicObject[]` | `getLeftwardRelationshipObjects(S_ClassObject relClass, SortSpecification sort)` returns all "left side" public objects that are related to this object by the specied Relationship Class.
`S_PublicObject[]` | `getLeftwardRelationshipObjects(java.lang.String relClassName, SortSpecification sort)` returns all "left side" public objects that are related to this object by the specied Relationship Class.
`S_Relationship[]` | `getLeftwardRelationships(S_ClassObject relClass, SortSpecification sort)` returns all "left side" relationship instances that are used to relate to this object to other PublicObjects.
`S_Relationship[]` | `getLeftwardRelationships(java.lang.String relClassName, SortSpecification sort)` returns all "left side" relationship instances that are used to relate to this object to other PublicObjects.
`protected long` | `getLeftwardRelationshipsCount(S_ClassObject relClass)`
`protected long` | `getLeftwardRelationshipsCount(java.lang.String relClassname)`
`java.lang.Long[]` | `getLinkIds()` Get the IDs of all Links that refer to this instance.
`S_Link[]` | `getLinks()` Get all Links that refer to this instance.
`protected long` | `getLockedForSessionId()` returns the session Id of the session that holds a session lock on the target object.
`S_LockObject` | `getLockObject()` Returns the lock object of this object
`protected S_DirectoryUser` | `getOwner()` getOwner - gets the owner of this object
`protected S_Folder` | `getPrimaryParentFolder()` Gets the primary parent folder for this object.
`protected java.lang.String[]` | `getPropagatedSecurityAttributeNames()` Gets the names of the PublicObject attributes that should be propagated as part of a propagating security operation.
`protected java.lang.String[]` | `getPropagatedSecurityColumnNames()` Gets the names of the PublicObject columns that should be propagated as part of a propagating security operation.
`java.lang.Long[]` | `getReferencingFolderIds(SortSpecification sort)` Get the IDs of all folders that contain this instance.
`S_Folder[]` | `getReferencingFolders(SortSpecification sort)` returns an array of S_Folders that reference this object
`protected S_PublicObject` | `getResolvedObject()` getResolvedObject - gets the resolved public object of this objec
`protected S_Relationship[]` | `getRightRelationships(java.lang.String relClassName)` getRightRelationships - gets all Relationship objects to the right of this object for a specified Relationship class.
`protected java.util.Vector` | `getRightwardRelationshipDatas(S_ClassObject relClass, SortSpecification sort)`
`protected java.util.Vector` | `getRightwardRelationshipDatas(java.lang.String relClassName, SortSpecification sort)`
`protected java.util.Vector` | `getRightwardRelationshipObjectDatas(S_ClassObject relClass, SortSpecification sort)`
`protected java.util.Vector` | `getRightwardRelationshipObjectDatas(java.lang.String relClassName, SortSpecification sort)`
`S_PublicObject[]` | `getRightwardRelationshipObjects(S_ClassObject relClass, SortSpecification sort)` returns all "right side" public objects that are related to this object by the specified Relationship Class.
`S_PublicObject[]` | `getRightwardRelationshipObjects(java.lang.String relClassName, SortSpecification sort)` returns all "right side" public objects that are related to this object by the specified Relationship Class.
`S_Relationship[]` | `getRightwardRelationships(S_ClassObject relClass, SortSpecification sort)` returns all "right side" relationship instances that are used to relate to this object to other PublicObjects.
`S_Relationship[]` | `getRightwardRelationships(java.lang.String relClassName, SortSpecification sort)` returns all "right side" relationship instances that are used to relate to this object to other PublicObjects.
`protected S_Relationship[]` | `getSpecificLeftRelationships(S_PublicObject source, java.lang.String relClassName)` getSpecificLeftRelationships - gets all Relationship objects to the left of this object for a specified Relationship class, and for a specific source object.
`protected S_Relationship[]` | `getSpecificRightRelationships(S_PublicObject target, java.lang.String relClassName)` getSpecificRightRelationships - gets all Relationship objects to the right of this object for a specified Relationship class, and for a specific target object.
`S_VersionDescription[]` | `getVersionDescriptions()` Get all VERSIONDESCRIPTIONs associated with this instance.
`protected void` | `handleCascade(OperationState opState, S_LibraryObject source, int cascadeType, S_LibraryObjectDefinition sdef, java.lang.Object customArg)` handle a cascaded operation initiated by (usually) another object.
`protected void` | `handleExtendedFreePolicy(OperationState opState, S_LibraryObjectDefinition def)` handleExtendedFreePolicy - handle any Policy actions associated with free().
`boolean` | `hasNameAttribute()` Override of hasNameAttribute(), to always return true for PublicObjects
`protected void` | `invokeLockingPolicy(S_PublicObject po, S_LibraryObjectDefinition def, S_LockObject lckobj, java.lang.String operation)`
`boolean` | `isAuditCertificateSecured()` Gets whether an audit certificate for the target object should be secured, meaning it should be restricted to administrators.
`protected boolean` | `isDeleted()` isDeleted() - get the "mark for delete" state
`boolean` | `isLocked()` returns true if the LockObject attribute is not null
`protected boolean` | `isLockedForSession()` returns true if there is a session lock held on this object.
`protected boolean` | `isLockedForSessionByCurrentSession()` returns true if there is a session lock held on this object, and it is held by the invoking session.
`boolean` | `isLockObjectEnabled()` See if LOCKOBJECT is enabled.
`static boolean` | `isLockObjectEnabled(S_LibrarySession session)` See if LOCKOBJECT is enabled.
`protected boolean` | `isOwner()` return true if the caller is the owner of this object
`boolean` | `isVersionable()` Returns true if this object can be versioned.
`protected void` | `postCreateAddToFolder(S_LibraryObjectDefinition sdef)`
`protected void` | `postDelete(OperationState opState, S_LibraryObjectDefinition def)` Update any system attributes appropriate for deleting this object after the object is marked for deletion
`protected void` | `postSecurityChangeAuditEvent(S_PublicObject domain, S_AccessControlList acl)` Posts an audit event for the security change operation.
`protected void` | `postUndelete(OperationState opState, S_LibraryObjectDefinition def)` Update any system attributes appropriate for deleting this object after the object is unmarked for deletion
`protected void` | `preDelete(OperationState opState, S_LibraryObjectDefinition def)` Update any system attributes appropriate for deleting this object before the object is marked for deletion
`protected void` | `preUndelete(OperationState opState, S_LibraryObjectDefinition def)` Update any system attributes appropriate for unDeleting this object before the object is unmarked for deletion
`protected void` | `propagateFreeIfNoFolderReferences(S_LibraryObjectDefinition def)` propagate the freeIfNoFolderReferences operation.
`protected void` | `propagateNameChanges(OperationState opState, S_LibraryObjectDefinition def)`
`protected void` | `propagateSecurityChanges(OperationState opState, S_LibraryObjectDefinition def)` Propagates security changes from this object to the objects secured by this object.
`protected void` | `propogateSettingsToProxyService(S_LibraryObjectDefinition def)` Propogate the secured by setting to the Proxy service.
`void` | `putProperty(AttributeValue av)` Adds a Property to this object's PropertyBundle.
`void` | `reassociateLinks(S_PublicObject newTarget)` Force all Link objects that refer to this instance to be re-assocated with the specified object.
`protected boolean` | `relationshipExists(S_PublicObject member, java.lang.String relClassName)` return indication of existence of a relationship of the specified relationship class.
`protected void` | `removeRelationship(java.lang.Long relId, java.lang.Long relClassId)`
`void` | `removeRelationship(S_Relationship rel)` removes the relationship; may cascade to left and right objects.
`protected void` | `removeRowFromAclProxyIfSecured(OperationState opState)` Remove the row corresponding to this object from the ACL proxy table.
`protected void` | `resolveACLSetting(S_LibraryObjectDefinition def)`
`protected void` | `resolveResolvedObject()` determine resolved object
`protected void` | `resolveSecuredBySettings(S_LibraryObjectDefinition def, boolean forInsert)`
`protected void` | `signalLeftRelationshipFreed(OperationState opState, S_Relationship leftRel, S_PublicObject leftPo)` a PublicObject to the left of us has been freed.
`protected void` | `signalRightRelationshipFreed(OperationState opState, S_Relationship rightRel, S_PublicObject rightPo)` a PublicObject to the right of us has been freed.
`protected void` | `undelete(OperationState opState)` undelete - restore an object from the user's wastebasket.
`protected void` | `undelete(OperationState opState, S_LibraryObjectDefinition def)` undelete - restore an object from the user's wastebasket.
`void` | `unlockForSession()` release session lock for this object
`protected void` | `updateFamily(S_Family family)` Explicitly update the Family attribute, based on a versioning operation.
`protected void` | `updateLastModifiedInfo()` Explicitly update the LastMOdifier and LastModifyDate attributes.
`protected void` | `updatePrimaryParentFolder(S_Folder parent)` Explicitly update the PrimaryParentFolder attribute, based on a folder add/remove operation.
`protected static S_PublicObject[]` | `vectorToSPublicObjectArray(S_LibrarySession sess, java.util.Vector vector)`
`protected void` | `verifyCanAddRelationship()` Verifies that Relationships can be added to the instance.
`protected void` | `verifyCanCreate(S_LibraryObjectDefinition def)` Verifies that the instance can be created.
`protected void` | `verifyCanFree()` Verifies that the instance can be freed.
`protected void` | `verifyCanLock()` Verifies that the instance can be locked.
`protected void` | `verifyCanRemoveRelationship()` Verifies that Relationships can be removed from the instance.
`protected void` | `verifyCanSetPolicy()` Verifies that Policies can be updated on the instance.
`protected void` | `verifyCanUnlock()` Verifies that the instance can be unlocked.
`protected void` | `verifyCanUpdate()` Verifies that the instance can be updated.
`protected void` | `verifyCanUseContentQuota(S_ContentQuota quota)` Verify that the current user can use the specified ContentQuota object.
`protected void` | `verifyGrantAccess()` Verifies that the caller has grant access to the object.
`protected void` | `verifyObjectNotLocked()` Checks the current lock state.
`protected void` | `verifyObjectNotLocked(S_LibraryObjectDefinition def)` Checks the current lock state.
`protected void` | `verifyPublicObjectPermission(long standardPermission, int errorCode)` Internal method used by the verifyCanXXX() methods on PublicObject

Methods inherited from class oracle.ifs.server.S_LibraryObject
`applyValueDefault, associatedPostFree, associatedPostInsert, associatedPreInsert, cascadeUpdate, checkRequiredForInsert, checkSettable, clearArrayTypeAttributeValues, clonePublicObjectAttribute, constructIdArray, constructIdArray, copy, copy, copyVectorToLibraryObjectArray, createInstance, deleteRows, deriveOwnerUniqueName, deriveOwnerUniqueName, deriveUppercasedAttribute, determineClassDomain, determinePolicy, determinePolicy, determineValueDefault, determineValueDomain, dispose, DYNLockRows, equals, executePolicyOperation, findPolicyFromPropertyBundleAv, free, free, getAttribute, getAttributeByUpperCaseName, getAuditCertificateName, getAuditDomainContext, getClassData, getClassId, getClassName, getClassObject, getData, getDefinition, getEffectivePolicyActionContexts, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getId, getLibraryConnection, getName, getObjectReferenceAttribute, getPropertyBundle, getPropertyValue, getResourceString, getResourceString, getService, getSession, getSessionInterface, getTraceLogger, handleEvent, hashCode, insertReferenceAttributes, insertRow, insertRows, invalidateState, invokeOperation, invokePolicyMethod, isBroadcastCreateEventEnabled, isInstanceOf, issueCascade, isTraced, lockRows, postEvent, postEvent, postFree, postInsert, postUpdate, preFree, preInsert, preUpdate, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, toString, trace, update, updateRows, verifyCanGetContent, verifyCanSetContent, verifyWriteableTransactionInProgress`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

See Also:
  Constant Field Values
(Unpublished)

### NAME_ATTRIBUTE

    protected static final java.lang.String NAME_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### FAMILY_ATTRIBUTE

    protected static final java.lang.String FAMILY_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### DELETOR_ATTRIBUTE

    protected static final java.lang.String DELETOR_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### RESOLVED_OBJECT_ATTRIBUTE

    protected static final java.lang.String RESOLVED_OBJECT_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### ACL_ATTRIBUTE

    protected static final java.lang.String ACL_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### OWNER_ATTRIBUTE

    protected static final java.lang.String OWNER_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### SECURINGPUBLICOBJECT_ATTRIBUTE

    protected static final java.lang.String SECURINGPUBLICOBJECT_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### EXPIRATIONDATE_ATTRIBUTE

    protected static final java.lang.String EXPIRATIONDATE_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### CREATOR_ATTRIBUTE

    protected static final java.lang.String CREATOR_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### LASTMODIFIER_ATTRIBUTE

    protected static final java.lang.String LASTMODIFIER_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### CREATEDATE_ATTRIBUTE

    protected static final java.lang.String CREATEDATE_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### LASTMODIFYDATE_ATTRIBUTE

    protected static final java.lang.String LASTMODIFYDATE_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### POLICYBUNDLE_ATTRIBUTE

    protected static final java.lang.String POLICYBUNDLE_ATTRIBUTE

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
  See Also:
    Constant Field Values
  (Unpublished)

### POLICY_ENUM_EXTENDEDFREE_INVALID_VALUE

    public static final int POLICY_ENUM_EXTENDEDFREE_INVALID_VALUE

See Also:
  Constant Field Values
(Unpublished)

### POLICY_ENUM_EXTENDEDFREE_IGNORE_OWNERSHIP

    public static final int POLICY_ENUM_EXTENDEDFREE_IGNORE_OWNERSHIP

See Also:
  Constant Field Values
(Unpublished)

### POLICY_ENUM_EXTENDEDFREE_REQUIRE_ADMIN

    public static final int POLICY_ENUM_EXTENDEDFREE_REQUIRE_ADMIN

See Also:
  Constant Field Values
(Unpublished)

Constructor Detail

### S_PublicObject

    protected S_PublicObject(S_LibrarySession session,
                             S_LibraryObjectData data)
                      throws IfsException

  Construct a S_PublicObject object. This is the standard variant.

  Parameters:
    `session` - current LibrarySession
    `data` - Data component
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### S_PublicObject

    protected S_PublicObject(S_LibrarySession session,
                             java.lang.Long classId)
                      throws IfsException

  Construct a S_PublicObject object. This variant is used for objects that have not been created in the database yet.

  Parameters:
    `session` - current LibrarySession
    `classId` - ID of the object's ClassObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### S_PublicObject

    protected S_PublicObject(S_LibrarySession session,
                             java.lang.Long id,
                             java.lang.Long classId)
                      throws IfsException

  Construct a S_PublicObject object. This variant is used for objects that are used for special purpose on the server side and do not need to be associated with a S_LoData. Do Not use this variant for general purpose use.

  Parameters:
    `session` - current LibrarySession
    `id` - ID of the object
    `classId` - ID of the object's ClassObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

Method Detail

### hasNameAttribute

    public boolean hasNameAttribute()
                             throws IfsException

  Description copied from class: `S_PublicObject`
  Override of hasNameAttribute(), to always return true for PublicObjects

  Overrides:
    `hasNameAttribute` in class `S_LibraryObject`
  Returns:
    true (as PublicObjects have a NAME attribute).
  Throws:
    `IfsException` - if operation fails.
  (Published)

### deriveDefinition

    protected void deriveDefinition(S_LibraryObjectDefinition sdef)
                             throws IfsException

  Description copied from class: `S_PublicObject`
  Add to the S_LibraryObjectDefinition for this class. This is called by getDefinition() on S_LibraryObject. This must call super.deriveDefinition() before applying any class-specific changes to the S_LibraryObjectDefinition object.

  Overrides:
    `deriveDefinition` in class `S_LibraryObject`
  Parameters:
    `sdef` - the S_LibraryObjectDefinition that contains the definition of the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### handleCascade

    protected void handleCascade(OperationState opState,
                                 S_LibraryObject source,
                                 int cascadeType,
                                 S_LibraryObjectDefinition sdef,
                                 java.lang.Object customArg)
                          throws IfsException

  Description copied from class: `S_PublicObject`
  handle a cascaded operation initiated by (usually) another object. This is overridden by classes to add custom handlers. It is ok if no class handles the cascade (that is implied to mean "no action needed").

  Overrides:
    `handleCascade` in class `S_LibraryObject`
  Parameters:
    `opState` - originating operation state
    `source` - object initiating this cascade request (not necessarily the original object)
    `cascadeType` - type of cascade request
    `sdef` - original Definition object
    `customArg` - any custom parameter.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFree

    protected void cascadeFree(OperationState opState,
                               S_LibraryObjectDefinition def)
                        throws IfsException

  Description copied from class: `S_PublicObject`
  cascade operations to be performed before freeing an object. This is overridden by classes that need to perform operations before successfully freeing the rows for the freed instance.

  Overrides:
    `cascadeFree` in class `S_LibraryObject`
  Parameters:
    `opState` - originating operation state
    `def` - original Definition object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeCopy

    protected void cascadeCopy(OperationState opState,
                               S_LibraryObjectDefinition def,
                               S_LibraryObject clone)
                        throws IfsException

  Description copied from class: `S_PublicObject`
  cascade operations to be performed before copying an object. This is overridden by classes that need to perform operations before successfully copying the instance.

  Overrides:
    `cascadeCopy` in class `S_LibraryObject`
  Parameters:
    `opState` - originating operation state
    `def` - original Definition object
    `clone` - the copied object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeDelete

    protected void cascadeDelete(OperationState opState,
                                 S_LibraryObjectDefinition def)
                          throws IfsException

  Description copied from class: `S_PublicObject`
  cascade operations to be performed before deleting an object. This is overridden by classes that need to perform operations before successfully deleting the rows for the freed instance.

  Parameters:
    `opState` - originating operation state
    `def` - original Definition object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeUndelete

    protected void cascadeUndelete(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_PublicObject`
  cascade operations to be performed before undeleting an object. This is overridden by classes that need to perform operations before successfully undeleting the rows for the freed instance.

  Parameters:
    `opState` - originating operation state
    `def` - original Definition object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreInsert

    protected void extendedPreInsert(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_PublicObject`
  Update any system attributes appropriate for creating this object

  Overrides:
    `extendedPreInsert` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `sdef` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPostInsert

    protected void extendedPostInsert(OperationState opState,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `S_PublicObject`
  operations to be performed after creating an object. This is overridden by classes that need to perform operations after successfully creating the rows for the new instance.

  Overrides:
    `extendedPostInsert` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `def` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### determineResolvedObject

    protected S_PublicObject determineResolvedObject()
                                              throws IfsException

  Description copied from class: `S_PublicObject`
  return the object we resolve to.

  Returns:
    the object we resolve to
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### resolveResolvedObject

    protected void resolveResolvedObject()
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  determine resolved object

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreUpdate

    protected void extendedPreUpdate(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_PublicObject`
  Update any system attributes appropriate for creating this object

  Overrides:
    `extendedPreUpdate` in class `S_LibraryObject`
  Parameters:
    `opState` - the operation state
    `sdef` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isLockObjectEnabled

    public boolean isLockObjectEnabled()
                                throws IfsException

  Description copied from class: `S_PublicObject`
  See if LOCKOBJECT is enabled.

  Returns:
    true if LCOKOBJECT is enabled
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isLockObjectEnabled

    public static boolean isLockObjectEnabled(S_LibrarySession session)
                                       throws IfsException

  Description copied from class: `S_PublicObject`
  See if LOCKOBJECT is enabled.

  Parameters:
    `session` - session context
  Returns:
    true if LCOKOBJECT is enabled
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPostUpdate

    protected void extendedPostUpdate(OperationState opState,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `S_PublicObject`
  extended operations to be performed after updating an object. This is overridden by classes that need to perform operations after updating this object in the database, but before commit.

  Overrides:
    `extendedPostUpdate` in class `S_LibraryObject`
  Parameters:
    `opState` - the Operation state
    `def` - the S_LibraryObjectDefinition that contains the updates.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### updateLastModifiedInfo

    protected void updateLastModifiedInfo()
                                   throws IfsException

  Description copied from class: `S_PublicObject`
  Explicitly update the LastMOdifier and LastModifyDate attributes. This is called when these two attributes should be updated even though an update operation is not performed (e.g. when an item is added to a Folder)

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### updatePrimaryParentFolder

    protected void updatePrimaryParentFolder(S_Folder parent)
                                      throws IfsException

  Description copied from class: `S_PublicObject`
  Explicitly update the PrimaryParentFolder attribute, based on a folder add/remove operation.

  Parameters:
    `parent` - the new primary parent folder; can be null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### updateFamily

    protected void updateFamily(S_Family family)
                         throws IfsException

  Description copied from class: `S_PublicObject`
  Explicitly update the Family attribute, based on a versioning operation.

  Parameters:
    `family` - the new family; can be null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreFree

    protected void extendedPreFree(OperationState opState,
                                   S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_PublicObject`
  operations to be performed before freeing an object. This is overridden by classes that need to perform operations after successfully deleting the rows for the freed instance.

  Overrides:
    `extendedPreFree` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `def` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPostFree

    protected void extendedPostFree(OperationState opState,
                                    S_LibraryObjectDefinition def)
                             throws IfsException

  Description copied from class: `S_PublicObject`
  Operations to be performed after freeing an object

  Overrides:
    `extendedPostFree` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreCopy

    protected void extendedPreCopy(OperationState opState,
                                   S_LibraryObjectDefinition sdef)
                            throws IfsException

  Description copied from class: `S_PublicObject`
  Operations to be performed prior to creating an object copy. The specified definition contains the simple copy made by invoking deriveDefinition() on the target object.

  Overrides:
    `extendedPreCopy` in class `S_LibraryObject`
  Parameters:
    `opState` - the OperationState
    `sdef` - any modifications to make to the copied object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreDelete

    protected void extendedPreDelete(OperationState opState,
                                     S_LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `S_PublicObject`
  operations to be performed before deleting an object. This is overridden by classes that need to perform operations before successfully marking the object for deletion.

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPostDelete

    protected void extendedPostDelete(OperationState opState,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `S_PublicObject`
  operations to be performed after deleting an object. This is overridden by classes that need to perform operations after successfully marking the object for deletion.

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPreUndelete

    protected void extendedPreUndelete(OperationState opState,
                                       S_LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `S_PublicObject`
  operations to be performed before undeleting an object. This is overridden by classes that need to perform operations before successfully unmarking the object for deletion.

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### extendedPostUndelete

    protected void extendedPostUndelete(OperationState opState,
                                        S_LibraryObjectDefinition def)
                                 throws IfsException

  Description copied from class: `S_PublicObject`
  operations to be performed after undeleting an object. This is overridden by classes that need to perform operations after successfully unmarking the object for deletion.

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### preDelete

    protected void preDelete(OperationState opState,
                             S_LibraryObjectDefinition def)
                      throws IfsException

  Description copied from class: `S_PublicObject`
  Update any system attributes appropriate for deleting this object before the object is marked for deletion

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### postDelete

    protected void postDelete(OperationState opState,
                              S_LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `S_PublicObject`
  Update any system attributes appropriate for deleting this object after the object is marked for deletion

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### preUndelete

    protected void preUndelete(OperationState opState,
                               S_LibraryObjectDefinition def)
                        throws IfsException

  Description copied from class: `S_PublicObject`
  Update any system attributes appropriate for unDeleting this object before the object is unmarked for deletion

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### postUndelete

    protected void postUndelete(OperationState opState,
                                S_LibraryObjectDefinition def)
                         throws IfsException

  Description copied from class: `S_PublicObject`
  Update any system attributes appropriate for deleting this object after the object is unmarked for deletion

  Parameters:
    `opState` - current operation state
    `def` - current object definition
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### delete

    protected void delete(OperationState opState)
                   throws IfsException

  Description copied from class: `S_PublicObject`
  delete - THE ONLY METHOD THAT SHOULD CALL THIS METHOD IS S_LibrarySession.DMDelete() (or this method recursively).

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### delete

    protected void delete(OperationState opState,
                          S_LibraryObjectDefinition def)
                   throws IfsException

  Description copied from class: `S_PublicObject`
  delete - THE ONLY METHOD THAT SHOULD CALL THIS METHOD IS S_LibrarySession.DMDelete() (or this method recursively).

  Parameters:
    `opState` - current operation state
    `def` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### undelete

    protected void undelete(OperationState opState)
                     throws IfsException

  Description copied from class: `S_PublicObject`
  undelete - restore an object from the user's wastebasket.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### undelete

    protected void undelete(OperationState opState,
                            S_LibraryObjectDefinition def)
                     throws IfsException

  Description copied from class: `S_PublicObject`
  undelete - restore an object from the user's wastebasket.

  Parameters:
    `opState` - current operation state
    `def` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isDeleted

    protected boolean isDeleted()
                         throws IfsException

  Description copied from class: `S_PublicObject`
  isDeleted() - get the "mark for delete" state

  Returns:
    true if the object is marked for deletion, false otherwise
  Throws:
    `IfsException`
  (Unpublished)

### DYNReplaceDeletor

    public java.io.Serializable DYNReplaceDeletor(java.io.Serializable payload)
                                           throws IfsException

  Description copied from class: `S_PublicObject`
  Changes the deletor of an object to the passed in user. The object must already be deleted, and admin mode must be enabled. Note that this operation does not cascade in like delete, undelete and free do.

  Parameters:
    `payload` - the id of the new user
  Returns:
    null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### DYNReplaceCreator

    public java.io.Serializable DYNReplaceCreator(java.io.Serializable payload)
                                           throws IfsException

  Description copied from class: `S_PublicObject`
  Changes the creator of an object to the passed in user. Admin mode must be enabled.

  Parameters:
    `payload` - the id of the new user
  Returns:
    null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### DYNReplaceModifier

    public java.io.Serializable DYNReplaceModifier(java.io.Serializable payload)
                                            throws IfsException

  Description copied from class: `S_PublicObject`
  Changes the last modifier of an object to the passed in user. Admin mode must be enabled.

  Parameters:
    `payload` - the id of the new user
  Returns:
    null
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isLocked

    public boolean isLocked()
                     throws IfsException

  Description copied from class: `S_PublicObject`
  returns true if the LockObject attribute is not null

  Returns:
    true if the lockobject attribute is not null, false otherwise
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isLockedForSession

    protected boolean isLockedForSession()
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  returns true if there is a session lock held on this object.

  Returns:
    true if there is a session lock held on this object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### unlockForSession

    public void unlockForSession()
                          throws IfsException

  Description copied from class: `S_PublicObject`
  release session lock for this object

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getLockedForSessionId

    protected long getLockedForSessionId()
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  returns the session Id of the session that holds a session lock on the target object. Returns 0 if no session lock is held.

  Returns:
    Session id of the session holding a session lock on this object, or 0 if no session lock is held.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getLockObject

    public S_LockObject getLockObject()
                               throws IfsException

  Description copied from class: `S_PublicObject`
  Returns the lock object of this object

  Returns:
    The lock object or null if object is unlocked
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isLockedForSessionByCurrentSession

    protected boolean isLockedForSessionByCurrentSession()
                                                  throws IfsException

  Description copied from class: `S_PublicObject`
  returns true if there is a session lock held on this object, and it is held by the invoking session.

  Returns:
    true if there is a session lock held on this object, and it is held by the invoking session.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isVersionable

    public boolean isVersionable()
                          throws IfsException

  Description copied from class: `S_PublicObject`
  Returns true if this object can be versioned. Equivalent to invoking the ISVERSIONABLE policy-driven abstract operation.

  Returns:
    true if this object can be versioned; false otherwise
  Throws:
    `IfsException` - if operation fails.
  (Published)

### verifyCanCreate

    protected void verifyCanCreate(S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that the instance can be created. This is called as part of the createInstance sequence, but still requires that the user has Create Access on the classAcl for the object's class.

  Overrides:
    `verifyCanCreate` in class `S_LibraryObject`
  Parameters:
    `def` - the definition
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanUpdate

    protected void verifyCanUpdate()
                            throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that the instance can be updated. This is called as part of the update() sequence, and requires that the user has SET_ATTRIBUTE Access on the object's acl.

  Overrides:
    `verifyCanUpdate` in class `S_LibraryObject`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanFree

    protected void verifyCanFree()
                          throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that the instance can be freed. This is called as part of the free() sequence, and requires that the user has DELETE Access on the object's acl.

  Overrides:
    `verifyCanFree` in class `S_LibraryObject`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyGrantAccess

    protected void verifyGrantAccess()
                              throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that the caller has grant access to the object. requires that the user has GRANT Access on the object's acl.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanLock

    protected void verifyCanLock()
                          throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that the instance can be locked. This requires that the user has Lock Access on the object's acl. This is checked only for hard and soft locks

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanUnlock

    protected void verifyCanUnlock()
                            throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that the instance can be unlocked. This requires that the user has UnLock Access on the object's acl. This is checked only for hard and soft locks

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanSetPolicy

    protected void verifyCanSetPolicy()
                               throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that Policies can be updated on the instance. This requires that the user has SetPolicy Access on the object's acl.

  Overrides:
    `verifyCanSetPolicy` in class `S_LibraryObject`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanAddRelationship

    protected void verifyCanAddRelationship()
                                     throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that Relationships can be added to the instance. This requires that the user has AddRelationship Access on the object's acl.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanRemoveRelationship

    protected void verifyCanRemoveRelationship()
                                        throws IfsException

  Description copied from class: `S_PublicObject`
  Verifies that Relationships can be removed from the instance. This requires that the user has RemoveRelationship Access on the object's acl.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanUseContentQuota

    protected void verifyCanUseContentQuota(S_ContentQuota quota)
                                     throws IfsException

  Description copied from class: `S_PublicObject`
  Verify that the current user can use the specified ContentQuota object. The target object is the object that is associated with the specified quota object.

  Throws:
    `IfsException` - (IFS-34806) if user cannot use the specified quota
  (Published)

### canUseContentQuota

    protected boolean canUseContentQuota(S_ContentQuota quota)
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  Returns true if the current user can use the specified ContentQuota object. The target object is the object that is associated with the specified quota object.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### checkAccess

    public boolean checkAccess(AccessLevel level)
                        throws IfsException

  Description copied from class: `S_PublicObject`
  Checks to see if the current user has the set of permissions specified for the target object. This will return true if the user owns the object, or if Administration mode is enabled. Otherwise, it will return true only if this object's ACL grants the specified permissions to the user.

  Parameters:
    `level` - the set of permissions which needs to verified.
  Returns:
    true if the current user has access
  Throws:
    `IfsException` - if the operation fails
  (Published)

### verifyPublicObjectPermission

    protected void verifyPublicObjectPermission(long standardPermission,
                                                int errorCode)
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  Internal method used by the verifyCanXXX() methods on PublicObject

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### resolveSecuredBySettings

    protected void resolveSecuredBySettings(S_LibraryObjectDefinition def,
                                            boolean forInsert)
                                     throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### propogateSettingsToProxyService

    protected void propogateSettingsToProxyService(S_LibraryObjectDefinition def)
                                            throws IfsException

  Description copied from class: `S_PublicObject`
  Propogate the secured by setting to the Proxy service. This method is only called when the securedBy value is not known at preInsert time, as is the case with the "transfer ownership" option in creating a VersionDescription.

  Throws:
    `IfsException`
  (Unpublished)

### resolveACLSetting

    protected void resolveACLSetting(S_LibraryObjectDefinition def)
                              throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getDefaultAclFromUserProfile

    protected AttributeValue getDefaultAclFromUserProfile(java.lang.Long classid)
                                                   throws IfsException

  Description copied from class: `S_PublicObject`
  Get the defaultACL for a specified class of object, based on the current user's primaryUserProfile's DEFAULTACLS propertyBundle.

  Parameters:
    `classid` - the classid being created.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### propagateNameChanges

    protected void propagateNameChanges(OperationState opState,
                                        S_LibraryObjectDefinition def)
                                 throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### propagateSecurityChanges

    protected void propagateSecurityChanges(OperationState opState,
                                            S_LibraryObjectDefinition def)
                                     throws IfsException

  Description copied from class: `S_PublicObject`
  Propagates security changes from this object to the objects secured by this object.

  If the current object's OWNER or ACL attributes are updated, then it updates those attributes on the secured objects as well. If the secured objects themselves are securing some other objects, then this method propagtes the security changes to them as well. This method gets a def of a PO that is being updated and then extracts the owner and acl attributes. Once extracted, it calls the other variant of the method that takes OWNER and ACL attributes.

  Parameters:
    `opState` - operation state
    `def` - definition being used to updated the PO
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getPropagatedSecurityAttributeNames

    protected java.lang.String[] getPropagatedSecurityAttributeNames()

  Description copied from class: `S_PublicObject`
  Gets the names of the PublicObject attributes that should be propagated as part of a propagating security operation.

  This list must always include the attributes ACL and OWNER. The list can be overridden to include other PublicObject attributes, so long as those attributes are scalar LibraryObject types (PublicObject, DirectoryObject, SystemObject, or SchemaObject).

  The related array returned by `getPropagatedSecurityColumnNames` must be the same length as the array returned by this method, and the values must have the same ordering.

  Returns:
    the array of attribute names
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPropagatedSecurityColumnNames

    protected java.lang.String[] getPropagatedSecurityColumnNames()

  Description copied from class: `S_PublicObject`
  Gets the names of the PublicObject columns that should be propagated as part of a propagating security operation.

  This array returned from this method must match up with the array returned from `getPropagatedSecurityAttributeNames`. The values in this array are the column names that match the corresponding attribute names defined in that other array.

  Returns:
    the array of column names, matching the attributes defined in the array returned from `getPropagatedSecurityAttributeNames`
  Throws:
    `IfsException` - if the operation fails
  (Published)

### postSecurityChangeAuditEvent

    protected void postSecurityChangeAuditEvent(S_PublicObject domain,
                                                S_AccessControlList acl)
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  Posts an audit event for the security change operation.

  Parameters:
    `domain` - domain context
    `acl` - new ACL
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### addCategory

    protected S_Category addCategory(S_LibraryObjectDefinition catdef)
                              throws IfsException

  Description copied from class: `S_PublicObject`
  Add a Category to the target object. Used as part of the copy operation (see S_Category.handleCascade()).

  Parameters:
    `catdef` - the S_LibraryObjectDefinition object that describes the category to create
  Returns:
    the newly created Category
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createCategories

    protected void createCategories(S_LibraryObjectDefinition sdef)
                             throws IfsException

  Description copied from class: `S_PublicObject`
  Create a set of categories.

  Called as part `extendedPostInsert` and `extendedPostUpdate` to create categories. Only creates them if indicated by the CreateCategoriesServerSideOption on the definition.

  Throws:
    `IfsException`
  (Unpublished)

### removeRowFromAclProxyIfSecured

    protected void removeRowFromAclProxyIfSecured(OperationState opState)
                                           throws IfsException

  Description copied from class: `S_PublicObject`
  Remove the row corresponding to this object from the ACL proxy table. ACL proxy table will have a row for this object only if the current object was secured by another public object using the securing public object mechanism.

  Parameters:
    `opState` - operation state; not used
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### forceSecuredObjectsToClear

    protected void forceSecuredObjectsToClear(OperationState opState)
                                       throws IfsException

  Description copied from class: `S_PublicObject`
  for objects that we secure, if they haven't been freed as part of the specified operation, then force them to clear their SecuringPublicObject setting. This will force them to get their own ACL setting, which will clone it if it is non-shared.

  Parameters:
    `opState` - operation state
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### handleExtendedFreePolicy

    protected void handleExtendedFreePolicy(OperationState opState,
                                            S_LibraryObjectDefinition def)
                                     throws IfsException

  Description copied from class: `S_PublicObject`
  handleExtendedFreePolicy - handle any Policy actions associated with free().

  Parameters:
    `opState` - the Operation state.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### freeNonsharedAcl

    protected void freeNonsharedAcl(OperationState opState)
                             throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### freeNonsharedLockObject

    protected void freeNonsharedLockObject(OperationState opState,
                                           S_LockObject ourlockobj)
                                    throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### postCreateAddToFolder

    protected void postCreateAddToFolder(S_LibraryObjectDefinition sdef)
                                  throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getReferencingFolders

    public S_Folder[] getReferencingFolders(SortSpecification sort)
                                     throws IfsException

  Description copied from class: `S_PublicObject`
  returns an array of S_Folders that reference this object

  Parameters:
    `sort` - the SortSpecification specifying how to sort the referencing folders
  Returns:
    an array of S_Folders that reference this object
  Throws:
    `IfsException` - if operation fails
  (Published)

### getReferencingFolderIds

    public java.lang.Long[] getReferencingFolderIds(SortSpecification sort)
                                             throws IfsException

  Description copied from class: `S_PublicObject`
  Get the IDs of all folders that contain this instance.

  Returns:
    the array of IDs of the parent folders
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getAnyFolderPath

    public java.lang.String getAnyFolderPath()
                                      throws IfsException

  Description copied from class: `S_PublicObject`
  Gets any Folder path to the target object, starting from the Root Folder. If no reachable path exists, return null. This method will only return a path that the requesting user would be able to traverse. The user must have at least the Discover permission on all of the Folders in the path.

  Returns:
    a Folder path to the target object or null if no reachable path exists.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAuditEventFolderContext

    public S_Folder getAuditEventFolderContext()
                                        throws IfsException

  Description copied from class: `S_PublicObject`
  Gets the folder context for the target of an Audit Event.

  Override to use the primary parent folder.

  Overrides:
    `getAuditEventFolderContext` in class `S_LibraryObject`
  Returns:
    the folder context for the target
  Throws:
    `IfsException` - if the operation fails

### isAuditCertificateSecured

    public boolean isAuditCertificateSecured()
                                      throws IfsException

  Description copied from class: `S_PublicObject`
  Gets whether an audit certificate for the target object should be secured, meaning it should be restricted to administrators.

  By default, all PublicObjects are secured; hence this override.

  Overrides:
    `isAuditCertificateSecured` in class `S_LibraryObject`
  Returns:
    true if an audit certificate for the target object should be secured; false otherwise
  Throws:
    `IfsException` - if the operation fails

### getConsumedStorage

    protected long getConsumedStorage()
                               throws IfsException

  Description copied from class: `S_PublicObject`
  Returns 0 as the storage consumed by PublicObject. Subclasses override this method to return the correct value ife necessary.

  Returns:
    consumed storage (0) for public object
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getAnyFolderPath

    public java.lang.String getAnyFolderPath(S_Folder reference)
                                      throws IfsException

  Description copied from class: `S_PublicObject`
  Gets any Folder path to the target object. If no reachable path exists, return null.

  Parameters:
    `reference` - the relative folder (if null, root is assumed)
  Returns:
    a Folder path to the target object or null if no reachable path exists.
  Throws:
    `IfsException` - if operation fails.
  See Also:
    `S_PublicObject.getAnyFolderPath(S_Folder, SortSpecification, FolderPathOptions)`
  (Published)

### getAnyFolderPath

    public java.lang.String getAnyFolderPath(S_Folder reference,
                                             SortSpecification sort)
                                      throws IfsException

  Description copied from class: `S_PublicObject`
  Gets any Folder path to the target object. If no reachable path exists, return null.

  Parameters:
    `reference` - the relative folder (if null, root is assumed)
    `sort` - how parent folders are to be sorted
  Returns:
    a Folder path to the target object or null if no reachable path exists.
  Throws:
    `IfsException` - if operation fails.
  See Also:
    `S_PublicObject.getAnyFolderPath(S_Folder, SortSpecification, FolderPathOptions)`
  (Published)

### getAnyFolderPath

    public java.lang.String getAnyFolderPath(S_Folder reference,
                                             SortSpecification sort,
                                             FolderPathOptions fpo)
                                      throws IfsException

  Description copied from class: `S_PublicObject`
  Gets any Folder path to the target object. If no reachable path exists, return null.

  Parameters:
    `reference` - the relative folder (if null, root is assumed)
    `sort` - how parent folders are to be sorted
    `fpo` - Options describing the path determination operation; optional; if null is specified, default beahvior will be in force.
  Returns:
    a Folder path to the target object or null if no reachable path exists.
  Throws:
    `IfsException` - if operation fails.
  See Also:
    `S_PublicObject.getAnyFolderPath(S_Folder, SortSpecification, FolderPathOptions, boolean, HashMap)`
  (Published)

### getAllFolderPaths

    public java.lang.String[] getAllFolderPaths()
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  Gets all Folder paths to the target object, starting from the Root Folder. If no reachable path exists, return null.

  Returns:
    all Folder paths to the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAllFolderPaths

    public java.lang.String[] getAllFolderPaths(S_Folder reference)
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  get all Folder paths to the target object. If no reachable paths exists, return null.

  Parameters:
    `reference` - the relative folder (if null, root is assumed)
  Returns:
    all Folder paths to the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAllFolderPaths

    public java.lang.String[] getAllFolderPaths(S_Folder reference,
                                                SortSpecification sort)
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  get all Folder paths to the target object. If no reachable paths exists, return null.

  Parameters:
    `reference` - the relative folder (if null, root is assumed)
    `sort` - how parent folders are to be sorted
  Returns:
    all Folder paths to the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAllFolderPaths

    public java.lang.String[] getAllFolderPaths(S_Folder reference,
                                                SortSpecification sort,
                                                FolderPathOptions fpo)
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  get all Folder paths to the target object. If no reachable paths exists, return null.

  Parameters:
    `reference` - the relative folder (if null, root is assumed)
    `sort` - how parent folders are to be sorted
    `fpo` - Options describing the path determination operation; optional; if null is specified, default beahvior will be in force.
  Returns:
    all Folder paths to the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### addRelationship

    public void addRelationship(S_PublicObject rightPo,
                                S_LibraryObjectDefinition def)
                         throws IfsException

  Description copied from class: `S_PublicObject`
  Add a relationship to another public object

  Parameters:
    `rightPo` - the right-hand object
    `def` - the relationship definition of the new relationship
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Published)

### addRelationship

    protected S_LibraryObjectData addRelationship(S_LibraryObjectDefinition def)
                                           throws IfsException

  Description copied from class: `S_PublicObject`
  Add a relationship to another public object

  Parameters:
    `def` - the relationship definition of the new relationship
  Throws:
    `IfsException` - if any other aspect of the operation fails.
  (Unpublished)

### removeRelationship

    protected void removeRelationship(java.lang.Long relId,
                                      java.lang.Long relClassId)
                               throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### removeRelationship

    public void removeRelationship(S_Relationship rel)
                            throws IfsException

  Description copied from class: `S_PublicObject`
  removes the relationship; may cascade to left and right objects.

  Parameters:
    `rel` - the Relationship instance to be removed
  Throws:
    `IfsException`
  (Published)

### getRightwardRelationshipObjectDatas

    protected java.util.Vector getRightwardRelationshipObjectDatas(S_ClassObject relClass,
                                                                   SortSpecification sort)
                                                            throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getRightwardRelationshipObjectDatas

    protected java.util.Vector getRightwardRelationshipObjectDatas(java.lang.String relClassName,
                                                                   SortSpecification sort)
                                                            throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getLeftwardRelationshipObjectDatas

    protected java.util.Vector getLeftwardRelationshipObjectDatas(S_ClassObject relClass,
                                                                  SortSpecification sort)
                                                           throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getLeftwardRelationshipObjectDatas

    protected java.util.Vector getLeftwardRelationshipObjectDatas(java.lang.String relClassName,
                                                                  SortSpecification sort)
                                                           throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getRightwardRelationshipDatas

    protected java.util.Vector getRightwardRelationshipDatas(S_ClassObject relClass,
                                                             SortSpecification sort)
                                                      throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getRightwardRelationshipDatas

    protected java.util.Vector getRightwardRelationshipDatas(java.lang.String relClassName,
                                                             SortSpecification sort)
                                                      throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getLeftwardRelationshipDatas

    protected java.util.Vector getLeftwardRelationshipDatas(S_ClassObject relClass,
                                                            SortSpecification sort)
                                                     throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getLeftwardRelationshipDatas

    protected java.util.Vector getLeftwardRelationshipDatas(java.lang.String relClassName,
                                                            SortSpecification sort)
                                                     throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getLeftwardRelationshipsCount

    protected long getLeftwardRelationshipsCount(S_ClassObject relClass)
                                          throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getLeftwardRelationshipsCount

    protected long getLeftwardRelationshipsCount(java.lang.String relClassname)
                                          throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### getFlags

    public long getFlags()
                  throws IfsException

  Description copied from class: `S_PublicObject`
  Gets the flags bitmask.

  Returns:
    the flags value; Returns 0 if no value is specified
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getFamily

    protected S_Family getFamily()
                          throws IfsException

  Description copied from class: `S_PublicObject`
  gets the S_Family of this object (or null for non-versioned)

  Throws:
    `IfsException`
  (Unpublished)

### getAcl

    protected S_AccessControlList getAcl()
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  gets the ACL for this object, which can be null.

  Returns:
    the ACL
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getLinks

    public S_Link[] getLinks()
                      throws IfsException

  Description copied from class: `S_PublicObject`
  Get all Links that refer to this instance.

  Returns:
    the array of Link objects.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getLinkIds

    public java.lang.Long[] getLinkIds()
                                throws IfsException

  Description copied from class: `S_PublicObject`
  Get the IDs of all Links that refer to this instance.

  Returns:
    the array of IDs of Link objects.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### reassociateLinks

    public void reassociateLinks(S_PublicObject newTarget)
                          throws IfsException

  Description copied from class: `S_PublicObject`
  Force all Link objects that refer to this instance to be re-assocated with the specified object. If the specified object is null, then all existing links should become "broken".

  Parameters:
    `newTarget` - the object that will become the associated object of all existing links to this object.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCategories

    public S_Category[] getCategories()
                               throws IfsException

  Description copied from class: `S_PublicObject`
  Get all categries associated with this instance.

  Returns:
    the array of category objects.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getCategories

    public S_Category[] getCategories(S_ClassObject classobj)
                               throws IfsException

  Description copied from class: `S_PublicObject`
  Returns the associated Category objects that are instances of the ClassObject (or one of its subclasses) specified. Returns null if no Category objects are associated.

  Parameters:
    `classobj` - the class of Category
  Returns:
    array of Category objects associated with the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getCategory

    public S_Category getCategory(S_ClassObject classobj)
                           throws IfsException

  Description copied from class: `S_PublicObject`
  Returns the associated Category object that is an instance of the ClassObject (or one of its subclasses) specified.

  The caller must be certain that no more than one category of the specified class exists, or be satisfied that the first category encountered be returned. Returns null if no Category object of the specified class exist.

  Parameters:
    `classobj` - the class of Category
  Returns:
    the Category associated with the target object, or null if none
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getCategories

    public S_Category[] getCategories(SortSpecification sort)
                               throws IfsException

  Description copied from class: `S_PublicObject`
  Get all categories associated with this instance.

  Returns:
    the array of category objects.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getVersionDescriptions

    public S_VersionDescription[] getVersionDescriptions()
                                                  throws IfsException

  Description copied from class: `S_PublicObject`
  Get all VERSIONDESCRIPTIONs associated with this instance.

  Returns:
    the array of VERSIONDESCRIPTION objects
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPrimaryParentFolder

    protected S_Folder getPrimaryParentFolder()
                                       throws IfsException

  Description copied from class: `S_PublicObject`
  Gets the primary parent folder for this object.

  Returns:
    the primary parent folder
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getOwner

    protected S_DirectoryUser getOwner()
                                throws IfsException

  Description copied from class: `S_PublicObject`
  getOwner - gets the owner of this object

  Returns:
    the owner
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isOwner

    protected boolean isOwner()
                       throws IfsException

  Description copied from class: `S_PublicObject`
  return true if the caller is the owner of this object

  Returns:
    true if the caller is the owner of this object
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getResolvedObject

    protected S_PublicObject getResolvedObject()
                                        throws IfsException

  Description copied from class: `S_PublicObject`
  getResolvedObject - gets the resolved public object of this objec

  Throws:
    `IfsException`
  (Unpublished)

### getAllLeftRelationships

    protected S_Relationship[] getAllLeftRelationships()
                                                throws IfsException

  Description copied from class: `S_PublicObject`
  getAllLeftRelationships - gets all Relationship objects to the left of this object.

  Returns:
    array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getLeftRelationships

    protected S_Relationship[] getLeftRelationships(java.lang.String relClassName)
                                             throws IfsException

  Description copied from class: `S_PublicObject`
  getLeftRelationships - gets all Relationship objects to the left of this object for a specified Relationship class.

  Returns:
    array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getAllRightRelationships

    protected S_Relationship[] getAllRightRelationships()
                                                 throws IfsException

  Description copied from class: `S_PublicObject`
  getAllRightRelationships - gets all Relationship objects to the right of this object.

  Returns:
    array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getRightRelationships

    protected S_Relationship[] getRightRelationships(java.lang.String relClassName)
                                              throws IfsException

  Description copied from class: `S_PublicObject`
  getRightRelationships - gets all Relationship objects to the right of this object for a specified Relationship class.

  Returns:
    array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSpecificRightRelationships

    protected S_Relationship[] getSpecificRightRelationships(S_PublicObject target,
                                                             java.lang.String relClassName)
                                                      throws IfsException

  Description copied from class: `S_PublicObject`
  getSpecificRightRelationships - gets all Relationship objects to the right of this object for a specified Relationship class, and for a specific target object.

  Returns:
    array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSpecificLeftRelationships

    protected S_Relationship[] getSpecificLeftRelationships(S_PublicObject source,
                                                            java.lang.String relClassName)
                                                     throws IfsException

  Description copied from class: `S_PublicObject`
  getSpecificLeftRelationships - gets all Relationship objects to the left of this object for a specified Relationship class, and for a specific source object.

  Returns:
    array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### freeIfNoFolderReferences

    protected void freeIfNoFolderReferences(S_LibraryObjectDefinition sdef)
                                     throws IfsException

  Description copied from class: `S_PublicObject`
  free this instance if there are no left-side FolderPathRelationships. Also, only perform this operation if the specified S_LibraryObjectDefinition parameter indicates that it should be performed.

  Parameters:
    `sdef` - A definition instance that contains the options for determining whether or not to free this instance. Also may contain free options that are passed along to free() in the event that this object is to be freed.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### propagateFreeIfNoFolderReferences

    protected void propagateFreeIfNoFolderReferences(S_LibraryObjectDefinition def)
                                              throws IfsException

  Description copied from class: `S_PublicObject`
  propagate the freeIfNoFolderReferences operation. This is overridden by classes (e.g. S_Folder) to propagate the operations described in freeIfNoFolderReferences().

  Parameters:
    `def` - A definition instance that contains the options for determining whether or not to free this instance.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getRightwardRelationshipObjects

    public S_PublicObject[] getRightwardRelationshipObjects(java.lang.String relClassName,
                                                            SortSpecification sort)
                                                     throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "right side" public objects that are related to this object by the specified Relationship Class. The Relationship class is specified by name.

  Parameters:
    `relClassName` - the name of the class of relationship on which to filter. Default is RELATIONSHIP
    `sort` - the sort specification
  Returns:
    an array of related PublicObjects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getRightwardRelationshipObjects

    public S_PublicObject[] getRightwardRelationshipObjects(S_ClassObject relClass,
                                                            SortSpecification sort)
                                                     throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "right side" public objects that are related to this object by the specified Relationship Class. The Relationship class is specified by ClassObject

  Parameters:
    `relClass` - the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of related PublicObjects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLeftwardRelationshipObjects

    public S_PublicObject[] getLeftwardRelationshipObjects(java.lang.String relClassName,
                                                           SortSpecification sort)
                                                    throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "left side" public objects that are related to this object by the specied Relationship Class. The filtering relationship class is specified by name.

  Parameters:
    `relClassName` - the name of the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of related PublicObjects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLeftwardRelationshipObjects

    public S_PublicObject[] getLeftwardRelationshipObjects(S_ClassObject relClass,
                                                           SortSpecification sort)
                                                    throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "left side" public objects that are related to this object by the specied Relationship Class. The filtering relationship class is specified by ClassObject

  Parameters:
    `relClass` - the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of related PublicObjects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getRightwardRelationships

    public S_Relationship[] getRightwardRelationships(java.lang.String relClassName,
                                                      SortSpecification sort)
                                               throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "right side" relationship instances that are used to relate to this object to other PublicObjects. The Filtering Relationship class is specified by name.

  Parameters:
    `relClassName` - the name of the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getRightwardRelationships

    public S_Relationship[] getRightwardRelationships(S_ClassObject relClass,
                                                      SortSpecification sort)
                                               throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "right side" relationship instances that are used to relate to this object to other PublicObjects. The Filtering Relationship class is specified by ClassObject.

  Parameters:
    `relClass` - the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLeftwardRelationships

    public S_Relationship[] getLeftwardRelationships(java.lang.String relClassName,
                                                     SortSpecification sort)
                                              throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "left side" relationship instances that are used to relate to this object to other PublicObjects. The Filtering Relationship class is specified by name.

  Parameters:
    `relClassName` - the name of the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLeftwardRelationships

    public S_Relationship[] getLeftwardRelationships(S_ClassObject relClass,
                                                     SortSpecification sort)
                                              throws IfsException

  Description copied from class: `S_PublicObject`
  returns all "left side" relationship instances that are used to relate to this object to other PublicObjects. The Filtering Relationship class is specified by ClassObject.

  Parameters:
    `relClass` - the class of relationship on which to filter.
    `sort` - the sort specifcation
  Returns:
    an array of Relationship objects
  Throws:
    `IfsException` - if operation fails.
  (Published)

### relationshipExists

    protected boolean relationshipExists(S_PublicObject member,
                                         java.lang.String relClassName)
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  return indication of existence of a relationship of the specified relationship class.

  Parameters:
    `member` - the meber to be checked
    `relClassName` - class name of the relationship class (e.g. "FOLDERRELATIONSHIP")
  Returns:
    true if there is a relationship to this specified object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### signalRightRelationshipFreed

    protected void signalRightRelationshipFreed(OperationState opState,
                                                S_Relationship rightRel,
                                                S_PublicObject rightPo)
                                         throws IfsException

  Description copied from class: `S_PublicObject`
  a PublicObject to the right of us has been freed. We are signalled by the Relationship. propogate to the left object after freeing this instance.

  Parameters:
    `opState` - the current operation state
    `rightRel` - the right Relationship
    `rightPo` - the right publicObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### signalLeftRelationshipFreed

    protected void signalLeftRelationshipFreed(OperationState opState,
                                               S_Relationship leftRel,
                                               S_PublicObject leftPo)
                                        throws IfsException

  Description copied from class: `S_PublicObject`
  a PublicObject to the left of us has been freed. We are signalled by the Relationship.

  Parameters:
    `opState` - the current operation state
    `leftRel` - the left Relationship
    `leftPo` - the left publicObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### verifyObjectNotLocked

    protected void verifyObjectNotLocked()
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  Checks the current lock state. If hardlocked, softlocked, locked by user other than current user, or session locked by sesssion other than current session, throws exception. Otherwise returns. Use this method to see if the object can be modified.

  Throws:
    `IfsException` - If the lock is in one of the above states.
  (Unpublished)

### verifyObjectNotLocked

    protected void verifyObjectNotLocked(S_LibraryObjectDefinition def)
                                  throws IfsException

  Description copied from class: `S_PublicObject`
  Checks the current lock state. If hardlocked, softlocked, locked by user other than current user, or session locked by sesssion other than current session, throws exception. Otherwise returns. Use this method to see if the object can be modified.

  Parameters:
    `def` - libraryobject definition that can define a custom policy to be used that will override the default defined by this object or the classobject.
  Throws:
    `IfsException` - If the lock is in one of the above states.
  (Unpublished)

### invokeLockingPolicy

    protected void invokeLockingPolicy(S_PublicObject po,
                                       S_LibraryObjectDefinition def,
                                       S_LockObject lckobj,
                                       java.lang.String operation)
                                throws IfsException

  Parameters:
    `po` - PublicObject for which to invoke the policy
    `lckobj` - LockObject on which policy is to be invoked
    `def` - Definition which contains any options for ignoring the check
    `operation` - The operation for which the policy is being invoked
  Throws:
    `IfsException`
  (Unpublished)
    Invoke a locking policy for the specified operation for the PublicObject

### vectorToSPublicObjectArray

    protected static S_PublicObject[] vectorToSPublicObjectArray(S_LibrarySession sess,
                                                                 java.util.Vector vector)
                                                          throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### putProperty

    public void putProperty(AttributeValue av)
                     throws IfsException

  Description copied from class: `S_PublicObject`
  Adds a Property to this object's PropertyBundle. Creates a new PropertyBundle if one does not already exist.

  Parameters:
    `av` - the name/value of the property to add
  Throws:
    `IfsException` - if operation fails.
  (Published)

### createDefaultPropertyBundle

    public S_PropertyBundle createDefaultPropertyBundle()
                                                 throws IfsException

  Description copied from class: `S_PublicObject`
  Creates a PropertyBundle for this PublicObject.

  Overrides:
    `createDefaultPropertyBundle` in class `S_LibraryObject`
  Returns:
    the default PropertyBundle
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### createDefaultPolicyPropertyBundle

    public S_PolicyPropertyBundle createDefaultPolicyPropertyBundle()
                                                             throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `S_PublicObject`
  Creates a PolicyPropertyBundle for this PublicObject.

  Overrides:
    `createDefaultPolicyPropertyBundle` in class `S_LibraryObject`
  Returns:
    the default PolicyPropertyBundle
  Throws:
    `IfsException` - if operation fails
  (Unpublished)

### constructPublicObjectArray

    protected static S_PublicObject[] constructPublicObjectArray(S_LibrarySession sess,
                                                                 java.lang.Long[] ids)
                                                          throws IfsException

  Description copied from class: `S_PublicObject`
  Construct a Folder array from an array of object IDs.

  Parameters:
    `sess` - the requesting session
    `ids` - the array of object IDs
  Returns:
    the array of Folders
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD